---
// Import layouts
import Layout from "@layouts/Layout.astro";

// Import components
import MetaLine from "@components/devices/MetaLine.astro";
import PortStatus from "@components/devices/PortStatus.astro";
import GlobalIssues from "@components/devices/GlobalIssues.astro";
import HelpMaintain from "@components/devices/HelpMaintain.astro";
import HelpTest from "@components/devices/HelpTest.astro";
import ReleaseChannels from "@components/devices/ReleaseChannels.astro";
import DeviceInfo from "@components/devices/DeviceInfo.astro";
import SupportStatus from "@components/devices/SupportStatus.astro";
import PortDocs from "@components/devices/PortDocs.astro";
import ContributorLinks from "@components/devices/ContributorLinks.astro";
import InstallerBanner from "@components/devices/InstallerBanner.astro";
import CommunityResources from "@components/banners/CommunityResources.astro";

import NavMenu from "@components/devices/NavMenu.astro";

import FlagIssue from "@components/devices/FlagIssue.astro";
import DiscussionsBar from "@components/devices/DiscussionsBar.astro";

// Import data
import getDevices from "@logic/build/getDevices.js";

// Export pages list
export async function getStaticPaths() {
  const devices = await getDevices("get-all-devices");
  return devices.map((device) => {
    return {
      params: {
        codename: device.releases.current.deviceParam
      },
      props: {
        device: device
      }
    };
  });
}

// Get current device
const { device } = Astro.props;

const isOldRelease =
  device.releases.current.obsolete || device.releases.current.supersededBy;

const pageMeta = {
  title: !isOldRelease
    ? device.name + " • Ubuntu Touch • Linux Phone"
    : device.name + " • Old Releases • Ubuntu Touch",
  meta: [
    {
      name: "keywords",
      content: device.seo
        ? device.seo.keywords
        : "Ubuntu Touch, " +
          device.name +
          ", Privacy phone, Linux smartphone, Linux on mobile"
    },
    {
      name: "description",
      content: device.seo
        ? device.seo.description
        : !isOldRelease
          ? "Flash your " +
            device.name +
            " with the latest version of the Ubuntu Touch operating system, a privacy focused OS developed by hundreds of people."
          : "Check old Ubuntu Touch releases for the " +
            device.name +
            ". If you want to use Ubuntu Touch as a daily driver, we recommend that you flash the latest version."
    },
    {
      property: "og:url",
      content: "https://devices.ubuntu-touch.io" + device.path
    },
    {
      property: "og:title",
      content: !isOldRelease
        ? device.name + " • Ubuntu Touch • Linux Phone"
        : device.name + " • Old Releases • Ubuntu Touch"
    },
    {
      property: "og:description",
      content: device.seo
        ? device.seo.description
        : !isOldRelease
          ? "Flash your " +
            device.name +
            " with the latest version of the Ubuntu Touch operating system, a privacy focused OS developed by hundreds of people."
          : "Check old Ubuntu Touch releases for the " +
            device.name +
            ". If you want to use Ubuntu Touch as a daily driver, we recommend that you flash the latest version."
    }
  ]
};
---

<Layout pageMeta={pageMeta}>
  <!-- Heading -->
  <div id="deviceOverview" class="scrollspy heading mt-lg-5">
    <!-- Title -->
    <a
      href={"https://devices.ubuntu-touch.io" + device.path}
      title={device.name + " can be a Linux phone"}
    >
      <h1 class="h3">{device.name}</h1>
    </a>
  </div>

  <MetaLine
    data={{
      name: device.name,
      codename: device.codename,
      noInstall: device.noInstall,
      portType: device.portType,
      disableBuyLink: device.disableBuyLink,
      buyLink: device.buyLink,
      price: device.price,
      portStatus: device.portStatus,
      isConvergenceEnabled: device.isConvergenceEnabled
    }}
  />

  {
    !!device.description && (
      <div>
        <p class="small mb-2 mt-4 light">Description</p>
        <p class="col-mb-2">{device.description}</p>
      </div>
    )
  }

  <!-- Warning for future releases data -->
  {
    device.warnings?.dev && (
      <div class="banner-grey unmaintained bold py-4">
        <p>
          This is a development release of Ubuntu Touch, unless you want to help
          building the OS we recommend you to use the{" "}
          {device.releases.default?.path ? (
            <a class="underline" href={device.releases.default.path}>
              stable release
            </a>
          ) : (
            "stable release"
          )}
          .
        </p>
      </div>
    )
  }

  <!-- Warning for previous releases data -->
  {
    device.warnings?.obsolete && (
      <div class="banner-grey unmaintained bold py-4">
        <p>
          You are viewing data for an obsolete Ubuntu Touch release that is kept
          for historical reasons, please use the{" "}
          {(!device.releases.current.default &&
            device.releases.default?.path) ||
          device.releases.suggested?.path ? (
            <a
              class="underline"
              href={
                (!device.releases.current.default &&
                  device.releases.default?.path) ||
                device.releases.suggested?.path
              }
            >
              latest stable release
            </a>
          ) : (
            "latest stable release"
          )}{" "}
          instead.
        </p>
      </div>
    )
  }

  <!-- Support status -->
  {
    !device.warnings?.obsolete && (
      <div
        class:list={[
          "banner-grey",
          "bold",
          "py-4",
          "mt-5",
          {
            unmaintained: device.supportStatus.number < 2,
            "banner-decoration-green": device.supportStatus.number == 4
          }
        ]}
      >
        {device.noInstall && (
          <p class="mb-3">
            {device.installLink ? (
              <a href={device.installLink} target="_blank">
                The UBports Installer
                <span class="underline">doesn't support</span> this device yet.
                Click here to find installation instructions.
              </a>
            ) : !!device.content.manualInstall ? (
              <span>
                The UBports Installer
                <span class="underline">doesn't support</span> this device yet.
              </span>
            ) : (
              <span>
                The UBports Installer
                <span class="underline">doesn't support</span> this device yet.
                Installation instructions not available at the moment.
              </span>
            )}
          </p>
        )}
        <p set:html={device.supportStatus.description} />
      </div>
    )
  }

  <PortStatus
    portStatus={device.portStatus}
    progressStage={device.progressStage}
    progress={device.progress}
    nextProgressStage={device.nextProgressStage}
    nextStageRequirements={device.nextStageRequirements}
    supportStatus={device.supportStatus.name}
    untestedCount={device.featureCount.untested}
    releases={device.releases.all}
    communitySize={device.communitySize}
  />

  <GlobalIssues
    globalIssues={device.globalIssuesList}
    unavailableFeatures={device.unavailableFeatures}
    unimplementedFeatures={device.unimplementedFeatures}
  />

  {
    device.featureCount.untested > 0 ? (
      <HelpTest
        name={device.name}
        untestedCount={device.featureCount.untested}
        contributors={device.contributors}
      />
    ) : (
      !device.noInstall && device.progress > 95 && <HelpMaintain />
    )
  }

  <SupportStatus
    supportIndicators={device.supportIndicators}
    progressStage={device.progressStage}
    lastActivity={device.sources?.lastActivity}
  />

  {
    !!device.releaseChannels.length && (
      <ReleaseChannels releaseChannels={device.releaseChannels} />
    )
  }

  {
    !!device.deviceInfo && (
      <DeviceInfo deviceInfo={device.deviceInfo} name={device.name} />
    )
  }

  {
    !!device.content.notes && (
      <>
        <h2 class="mt-5 mb-1 h3">Maintainer notes</h2>
        <div
          class="markdown-content mt-3 mb-2"
          set:html={device.content.notes}
        />
      </>
    )
  }

  <!-- Docs -->
  {
    (device.portType || device.docLinks) && (
      <PortDocs
        portType={device.portType}
        portTypeDescription={device.portTypeDescription}
        kernelVersion={device.kernelVersion}
        docLinks={device.docLinks}
      />
    )
  }

  <!-- Contributors & Discussions -->
  {
    (device.contributors || device.externalLinks) && (
      <ContributorLinks
        externalLinks={device.externalLinks}
        contributors={device.contributors}
        credits={device.content.credits}
      />
    )
  }

  {
    !device.noInstall && (
      <InstallerBanner
        instructions={device.installerInstructions}
        mdinstructions={device.content.preinstall}
      />
    )
  }

  {
    device.noInstall && device.content.manualInstall && (
      <>
        <h2 class="mt-2 mb-3 h3">Manual installation instructions</h2>
        <div class="banner-grey bold py-4 mt-1 unmaintained">
          <p>
            Manual installation is not supported by the community and is
            discouraged,
          </p>
          <p>
            if you do run into problems, only the porter will be able to help
            you.
          </p>
        </div>
        <div
          class="markdown-content mt-2 mb-5"
          set:html={device.content.manualInstall}
        />
      </>
    )
  }

  {
    !device.noInstall &&
      device.featureCount.untested == 0 &&
      device.progress > 95 && <CommunityResources />
  }

  <NavMenu availableData={device.enabledSections} />
  <FlagIssue deviceName={device.name} issuesLink={device.sources?.issuesLink} />
  <DiscussionsBar
    deviceName={device.name}
    developerReport={device.path + "/developer"}
    invalidPropCount={device.notValid.length}
    communityLinks={device.communityHelp}
    forumTopics={device.forumTopics}
    subforumLink={"https://forums.ubports.com/category/" + device.subforum}
  />
</Layout>
